// BladeEncVB.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "bladedll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE BladeEncVBDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("BLADEENCVB.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(BladeEncVBDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(BladeEncVBDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("BLADEENCVB.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(BladeEncVBDLL);
	}
	return 1;   // ok
}

BEINITSTREAM	beInitStream;
BEENCODECHUNK	beEncodeChunk;
BEDEINITSTREAM	beDeinitStream;
BECLOSESTREAM	beCloseStream;
BEVERSION		beVersion;

_declspec(dllexport) long _stdcall InitializeDLL(void)
{
	// Load BladeEnc.DLL
	
	HINSTANCE hBladeDLL = LoadLibrary("BLADEENC.DLL");
	
	if(!hBladeDLL)	{
		return -1;
	}
	
	// Get Interface
	
	beInitStream	= (BEINITSTREAM) GetProcAddress(hBladeDLL, TEXT_BEINITSTREAM);
	beEncodeChunk	= (BEENCODECHUNK) GetProcAddress(hBladeDLL, TEXT_BEENCODECHUNK);
	beDeinitStream	= (BEDEINITSTREAM) GetProcAddress(hBladeDLL, TEXT_BEDEINITSTREAM);
	beCloseStream	= (BECLOSESTREAM) GetProcAddress(hBladeDLL, TEXT_BECLOSESTREAM);
	beVersion		= (BEVERSION) GetProcAddress(hBladeDLL, TEXT_BEVERSION);

	if(!beInitStream || !beEncodeChunk || !beDeinitStream || !beCloseStream || !beVersion)	{
		return -2;
	}

	return 0;
}

/*
_declspec(dllexport) long _stdcall  blInitStream (PBE_CONFIG beConfig,
												  unsigned long *dwSamples,
												  unsigned long *dwMP3Buffer,
												  PHBE_STREAM hbeStream)
*/

_declspec(dllexport) long _stdcall  blInitStream (long SRate,
												  char Mode,
												  int Bitrate,
												  unsigned long *dwSamples,
												  unsigned long *dwMP3Buffer,
												  PHBE_STREAM hbeStream)
{
	BE_ERR err;
	BE_CONFIG beConfig;
	
	beConfig.dwConfig = BE_CONFIG_MP3;
	
	beConfig.format.mp3.dwSampleRate	= SRate;
	beConfig.format.mp3.byMode			= Mode;
	beConfig.format.mp3.wBitrate		= Bitrate;
	beConfig.format.mp3.bCopyright		= FALSE;
	beConfig.format.mp3.bCRC			= FALSE;
	beConfig.format.mp3.bOriginal		= FALSE;
	beConfig.format.mp3.bPrivate		= FALSE;
	
	err = beInitStream(&beConfig, dwSamples, dwMP3Buffer, hbeStream);

	return err;
}


_declspec(dllexport) long _stdcall  blEncodeChunk (HBE_STREAM hbeStream,
												   long nSamples,
												   PSHORT pSamples,
												   PBYTE pOutput, 
												   PDWORD pdwOutput)
{
	BE_ERR err;
	err = beEncodeChunk(hbeStream, nSamples, pSamples, pOutput, pdwOutput);
	return err;
}

_declspec(dllexport) long _stdcall  blDeinitStream(HBE_STREAM hbeStream, 
												   PBYTE pOutput,
												   PDWORD pdwOutput)
{
	BE_ERR err;
	err = beDeinitStream(hbeStream, pOutput, pdwOutput);
	return err;
}

_declspec(dllexport) long _stdcall  blCloseStream (HBE_STREAM hbeStream)
{
	BE_ERR err;
	err = beCloseStream(hbeStream);
	return err;
}

_declspec(dllexport) long _stdcall  blGetVersion (PBE_VERSION Version)
{
	beVersion(Version);
	return 0;
}

_declspec(dllexport) long _stdcall  ChangeSoundVolume (short *InOut, long nSamples, short nChannels,
													   double LVolume, double RVolume)
{
	long k, t;
	
	if(nChannels == 1)
		for(k = 0; k < nSamples; k++)
		{
			t = long(double(*InOut) * LVolume);
			if(t >  32767) t =  32767;
			if(t < -32768) t = -32768;
			*(InOut++) = short(t);
		}
	else if(nChannels == 2)
		for(k = 0; k < nSamples; k+=2)
		{
			t = long(double(*InOut) * LVolume);
			if(t >  32767) t =  32767;
			if(t < -32768) t = -32768;
			*(InOut++) = short(t);
			
			t = long(double(*InOut) * RVolume);
			if(t >  32767) t =  32767;
			if(t < -32768) t = -32768;
			*(InOut++) = short(t);
		}

	return 0;
}

_declspec(dllexport) long _stdcall  ChangeSoundVolumeB (PBYTE InOut, long nSamples, short nChannels,
													   double LVolume, double RVolume)
{
	return ChangeSoundVolume((short *)InOut, nSamples, nChannels, LVolume, RVolume);
}